<?php

class Main extends CI_Controller {

    function Main() {
        parent::__construct();
    }

    /*
     * Index function for the web page, main controller.
     * This function call the views: header, blog, footer.
     */

    function index() {
        $data['title'] = 'Home';
        $data['heading'] = 'Welcome to our project'; //e-reader
        $data['web_name'] = 'E@project'; //E@reader
        $this->generate_header($data);
        $this->load->view('main_view', $data);
        $this->generate_footer();
    }

    //Create header before to be loaded
    private function generate_header($data) {
        //if user is logged then don't show form, show welcome message
        $data['is_logged'] = $this->is_logged_in();
        if ($data['is_logged']) {
            $this->load->model('clients_model');
            $data['user_nick'] = $this->clients_model->get_nick();
            $data['message'] = "You are logged in :D";
            $this->load->view('common/header_view', $data);
        } else {
            $data['message'] = "You are NOT logged in :(";
            $this->load->view('common/header_view', $data);
        }
    }

    //Create footer before to be loaded
    private function generate_footer() {
        $this->load->view('common/footer_view');
    }

    //View to show Advertisement
    function legal_advertisement() {
        $this->load->view('information/legal_advertisement_view');
    }

    //Try to create a librarie with this function and the nex after this one.
    function validate_credentials() {
        // Load client model to validate the account, that is trying to log in.
        // If it doesn't work go back to main page, if works create session and
        // you are able to download everything.

        $this->load->model('clients_model');
        $query = $this->clients_model->validate();
        if ($query) {
            $data = array('email' => $this->input->post('email'),
                'is_logged_in' => true);
            $this->session->set_userdata($data);
            redirect('test');
        } else {
            //Go back to main page
            redirect('');
        }
    }

    //View to create an account
    function signup() {
        $data['message_error'] = 'Welcome to our community';
        $this->load->view('signup_view', $data);
    }

    //Create an Account
    function create_account() {
        //Check rules to confirm that everything is well done, error message.
        $this->load->library('form_validation');
        $this->load->model('clients_model');
        if ($this->form_validation->run('signup') == TRUE) {
            if ($this->clients_model->create_account()) {
                redirect('');
            }
        } else {
            $this->load->view('signup_view');
        }
    }

    //check if the user is logged on the page
    private function is_logged_in() {
        $is_logged_in = $this->session->userdata('is_logged_in');
        if (!isset($is_logged_in) OR $is_logged_in != TRUE) {
            return FALSE;
        } else {
            return TRUE;
        }
    }

    //Log out the user, delete cookie and session.
    function logout(){
        
    }
}

