<?php

class Site extends CI_Controller {

    function Site() {
        parent::__construct();
    }

    /*
     * Index function for the web page, site controller.
     * This function keep the most important function
     */

    function index() {
        $data['title'] = 'Home';
        $data['heading'] = 'Welcome to our project'; //e-reader
        $data['web_name'] = 'E@project'; //E@reader
        $this->load->library('common');
        $this->common->generate_header($data);
        $this->load->view('site_view', $data);
        $this->common->generate_footer();
    }

    function about_us() {
        $this->load->view('information/about_us_view');
    }

    //Create an Account
    function create_account() {
        //Check rules to confirm that everything is well done, error message.
        $this->load->library('form_validation');
        $this->load->model('clients_model');

        if ($this->form_validation->run('signup') == TRUE) {
            //It pass signup rules
            if ($this->clients_model->create_account()) {
                $this->successful();
            } else {
                $data['message'] = "You can not create 2 accounts with the same 
                    email, thhis email is already in use, sorry 8)";
                $data['uri'] = 'site/signup';
                $this->load->view('error_view', $data);
            }
        } else {//It doesn't pass the signup's rules
            $this->signup();
        }
    }

    //Load view to show Advertisement
    function legal_advertisement() {
        $this->load->view('information/legal_advertisement_view');
    }

    //Validate email and password to log in the users.
    function login() {
        // Load client model to validate the account, that is trying to log in.
        // If it doesn't work go back to site page, if works create session and
        // you are able to download everything.

        $this->load->model('clients_model');
        $query = $this->clients_model->validate();
        if ($query) {
            $data = array('email' => $this->input->post('email'),
                'is_logged_in' => true);
            $this->session->set_userdata($data);
            redirect('');
        } else {
            //Go back to site page
            redirect('');
        }
    }

    //Log out the user, delete cookie and session.
    function logout() {
        $this->load->model('clients_model');
        $this->clients_model->logout();
    }

    //Load view to create an account.
    function signup() {
        $this->load->view('signup_view');
    }

    //Load successful view after create account.
    protected function successful() {
        $this->load->view('success_view');
    }

    //Get data to post('search') to look for in the DB
    function searcher() {
        //Use switch to choose between what field in the DB we want to find in.
        switch ($this->input->post('search')) {
            case 0:
                $table = 'book';
                break;
            case 1:
                $table = 'author';
                break;
            case 2:
                $table = 'editorial';
                break;
            case 3:
                $table = 'thematic';
                break;
            default:
                break;
        }

        $this->load->model('searcher_model');
        $query['books_searched'] = $this->searcher_model->search_books($table);

        if (!$query['books_searched']) {
            $data['message'] = "No results found.";
            $data['uri'] = '';
            $this->load->view("error_view", $data);
        } else {
            $this->searched_view($query);
        }
    }

    function searched_view($data) {

        $data['title'] = 'Home';
        $data['heading'] = 'Welcome to our project'; //e-reader
        $this->load->library("common");
        $this->common->generate_header($data);
        $this->load->view("searcher_view", $data);
        $this->common->generate_footer();
    }

}
